<?php
if (!defined("CHECK")) die( header('Location: /404/') );
class QIWI {
    public $iQiwiAccount, $aBalances = array( 'USD' => 0, 'RUB' => 0, 'EUR' => 0, 'KZT' => 0 );
    private $sCookies = null;
   
    public function __construct( $iQiwiAccount, $sPassword ) {
      	$qiwi_url = 'https://w.qiwi.com/';
		$curl = new curl ();
		$curl->set_useragent('Mozilla/5.0 (Windows NT 6.1; WOW64; rv:22.0) Gecko/20100101 Firefox/22.0'); 
		$curl->set_httpheader(array('Accept: application/json, text/javascript, */*; q=0.01','X-Requested-With: XMLHttpRequest'));
		$curl_token = json_decode( $curl->post($qiwi_url.'auth/login.action','login='.$iQiwiAccount.'&password='.$sPassword) );
		if ($curl_token->code->value != 7) exit("Ошибка");
		$auth_token = $curl_token->data->token;
		$auth_2nd = json_decode( $curl->post($qiwi_url.'auth/login.action','login='.$iQiwiAccount.'&password='.$sPassword.'&loginToken='.$auth_token) );
		$this->sCookies = $curl->get_cookie();
		if ($auth_2nd->code->value != 0) exit("сервер QIWI отклонил запрос - попробуйте позднее");

        # Получение информации об qiwi.кошельке :
/*        if( ($aResponse = @json_decode( $this->request( 'person/state.action' ), true )) === false )
            throw new Exception( 'fatal error' );
        if( !is_array( $aResponse['data'] ) || !isset( $aResponse['data']['person'] ) || !isset( $aResponse['data']['balances'] ) )
            throw new Exception( $aResponse );
        $this->iQiwiAccount = $aResponse['data']['person'];
        foreach( $aResponse['data']['balances'] as $sEquivalent => $dBalance )
            $this->aBalances[$sEquivalent] = $dBalance;*/

    }
    public function GetHistory( $sStartDate, $sFinishDate ) {

        $qiwi_url = 'https://w.qiwi.com/';
        # Получение списка транзакций :
        $curl = new curl ();
        $curl->add_cookie($this->sCookies);
        $sResult = $curl->get($qiwi_url.'user/report/list.action?daterange=true&start='.$sStartDate.'&finish='.$sFinishDate);

        $aTransactions = array();
        foreach( explode( '</div><div class="reportsLine ', str_replace( '> <', '><', preg_replace( '!\s+!u', ' ', $sResult ) ) ) as $iKey => $sValue ) {
            if( $iKey == 0 )
                continue;
            
            $aData = array();
            
            # Получение суммы счета :
            $aData['iID'] = explode( 'class="transaction">', $sValue );
            if( count( $aData['iID'] ) < 2 )
                continue;
            $aData['iID'] = explode( '</', $aData['iID'][1] );
            $aData['iID'] = trim( $aData['iID'][0] );
            
            # Получение даты и время :
            $aData['sDate'] = explode( 'class="date">', $sValue );
            $aData['sDate'] = explode( '</', $aData['sDate'][1] );
            $aData['sDate'] = trim( $aData['sDate'][0] );
            $aData['sTime'] = explode( 'class="time">', $sValue );
            $aData['sTime'] = explode( '</', $aData['sTime'][1] );
            $aData['sTime'] = trim( $aData['sTime'][0] );
            
            # Получение суммы и валюты счета :
            $aData['sAmount'] = explode( 'class="originalExpense"><span>', $sValue );
            $aData['sAmount'] = explode( '</', $aData['sAmount'][1] );
            $aData['sAmount'] = trim( $aData['sAmount'][0] );
            
            # Получение суммы счета :
            $aData['dAmount'] = preg_replace( '/[^0-9\.]+/', '', str_replace( ',', '.', $aData['sAmount'] ) ) - 0;
            
            # Получение валюты счета :
            $aData['sCurrency'] = mb_strpos( $aData['sAmount'], 'руб.' ) !== false ? 'RUB' : (mb_strpos( $aData['sAmount'], 'долл.' ) !== false ? 'USD' : (mb_strpos( $aData['sAmount'], 'тенге.' ) !== false ? 'KZT' : 'NAN'));
            
            # Получение номера телефона корреспондента :
            $aData['iOpponentPhone'] = explode( 'class="opNumber">', $sValue );
            $aData['iOpponentPhone'] = explode( '</', $aData['iOpponentPhone'][1] );
            $aData['iOpponentPhone'] = trim( str_replace( '+', '', $aData['iOpponentPhone'][0] ) );
            
            # Получение примечания :
            $aData['sComment'] = explode( 'class="comment">', $sValue );
            $aData['sComment'] = explode( '</', $aData['sComment'][1] );
            $aData['sComment'] = html_entity_decode( trim( $aData['sComment'][0] ), ENT_QUOTES, 'UTF-8' );
            
            # Прибыль или расход ?
            $aData['sType'] = mb_strpos( $sValue, 'IncomeWithExpend expenditure' ) !== false ? 'EXPENDITURE' : (mb_strpos( $sValue, 'IncomeWithExpend income' ) !== false ? 'INCOME' : 'NAN');
            
            # Получение статуса транзакции :
            $aData['sStatus'] = explode( '"', $sValue );
            $aData['sStatus'] = trim( $aData['sStatus'][0] );
            
            # Дополнительные проверки :
            if( $aData['iID'] == false ) {
                $aData['iID'] = explode( '{"txn":', $sValue );
                $aData['iID'] = explode( '}', $aData['iID'][1] );
                $aData['iID'] = $aData['iID'][0];
            }
            
            $aTransactions['ID-'.$aData['iID']] = $aData;
        }
        return $aTransactions;
    }

    function check_qiwi($qiwi_num,$qiwi_pass) {
        try {
            $qiwi = new QIWI($qiwi_num,$qiwi_pass);
        } catch (Exception $e) {
            die($e->getMessage());
        }
        return true;
    }



    function qiwi_pay($qiwi_num,$qiwi_pass,$bill,$price) {
        $date1 = date('d.m.Y',strtotime('-2 day'));
        $date2 = date('d.m.Y',strtotime('+1 day'));
        $operations = $this->GetHistory($date1,$date2);

        $result = false;
        foreach($operations as $operation)
        {

            if(number_format($operation['dAmount'], 2, '.', '') == $price && $operation['sComment'] == $bill && ($operation['sStatus'] == 'status_SUCCESS' or $operation['sStatus'] == 'SUCCESS') and $operation['sCurrency'] == 'RUB')
            {
                $result = $operation;
            }
        }

        return $result;
    }


}