<?php
if (!defined("CHECK")) die( header('Location: /404/') );
$this->title = 'Управление доменом магазина';

if (empty($_SESSION['auth'])):
	header('Location: /auth/');
	exit;
endif;
$tk = new token();
$check_values = new filter();

$err[0] = '';
$err[1] = '';
$err[2] = '';

$get_user = $db->row("SELECT * FROM user WHERE id = ?", array($_SESSION['auth']['id']));
$get_shop = $db->row("SELECT * FROM shop WHERE domain = ? AND id_user = ?", array($_GET['shop'], $_SESSION['auth']['id']));
$get_shop_domain = $db->row("SELECT * FROM shop_domain WHERE id_shop = ?", array($get_shop['id']));

if (!empty($_POST['alias'])):

	$alias = strtolower($_POST['alias']);
	$get_shop_pay = $db->row("SELECT * FROM shop WHERE domain = ? AND id_user = ?", array($alias, $_SESSION['auth']['id']));
	$get_shop_notpay = $db->row("SELECT * FROM shop_payments WHERE domain = ? AND status = 'Не оплачен' AND id_user = ?", array($alias, $_SESSION['auth']['id']));

	if ($get_shop_pay):
		$err[0] = '<div class="input-error error">Домен занят!</div>';
	endif;

	if ($get_shop_notpay):
		$err[0] = '<div class="input-error error">Домен занят, но в течении суток может освободиться!</div>';
	endif;

endif;

// Перезаписываем информацию
if (
  !empty($_POST['token']) and 
  $tk->check($_POST['token']) and 
  $check_values->check('alias','post','regexp','~^[A-Za-z0-9-]{3,15}$~') and 
  empty($get_shop_pay) and 
  empty($get_shop_notpay) and 
  ($get_user >= $cost['domain_change'])
  ):

	$final_sum = $get_user['balance'] - $cost['domain_change'];
	$db->update("UPDATE user SET balance = ? WHERE id = ?", array($final_sum, $get_user['id']));
	$db->update("UPDATE shop SET domain = ? WHERE id = ?", array($alias, $get_shop['id']));
	$db->insert("INSERT INTO shop_payments (id_user, count, sum, type, status, domain, paymethod) VALUES (?, ?, ?, ?, ?, ?, ?)", array($_SESSION['auth']['id'], 1, $cost['domain_change'], 'Изменение домена', 'Оплачен', $alias, 'balance'));


	header('Location: /shops/');
	exit;

endif;
// Перезаписываем информацию



// Привязываем собственный домен
if (empty($get_shop_domain) and 
	!empty($_POST['token']) and 
	$tk->check($_POST['token']) and 
	$check_values->check('mydomain','post','regexp','~^[A-Za-zА-Яа-я0-9]{1,20}[-]{0,1}[A-Za-zА-Яа-я0-9]{1,20}\.([A-Za-z]{2,10}|[A-Za-z]{2,10}\.[A-Za-z]{2,10}|рф)$~')
	):

	$alias = strtolower($_POST['mydomain']);

	if (!$db->row("SELECT * FROM shop_domain WHERE domain = ?", array($alias))):
		$db->insert("INSERT INTO shop_domain (id_shop, domain) VALUES (?, ?)", array($get_shop['id'], $alias));
		$err[2] = '<div class="success">Домен успешно привязан!</div>';
	else:
		$err[1] = '<div class="input-error error">Этот домен уже привязан другим магазином!</div>';
	endif;

elseif(empty($get_shop_domain) and !empty($_POST['mydomain'])):
	$err[1] = '<div class="input-error error">Ошибка привязки домена!</div>';
endif;
// Привязываем собственный домен


// Отвязываем собственный домен
if ($get_shop_domain and 
	!empty($_POST['token']) and 
	$tk->check($_POST['token']) and 
	!empty($_POST['deletemydomain'])
	):

	$db->delete("DELETE FROM shop_domain WHERE id_shop = ?", array($get_shop['id']));

endif;
// Отвязываем собственный домен




$get_user = $db->row("SELECT * FROM user WHERE id = ?", array($_SESSION['auth']['id']));
$get_shop = $db->row("SELECT * FROM shop WHERE domain = ? AND id_user = ?", array($_GET['shop'], $_SESSION['auth']['id']));
$get_shop_domain = $db->row("SELECT * FROM shop_domain WHERE id_shop = ?", array($get_shop['id']));

$token = $tk->input();
require $_SERVER["DOCUMENT_ROOT"].'/template/general/shop/rename.tpl';